<template>
  <div class="ele-body">
    <el-card shadow="never" v-loading="loading">
      <div class="ele-border-lighter form-content" v-loading="loading">
        <search-quotation @search="reload"> </search-quotation>

        <!-- 数据表格 -->
        <ele-pro-table
          ref="table"
          :columns="columns"
          :datasource="datasource"
          height="calc(100vh - 375px)"
          full-height="calc(100vh - 116px)"
          tool-class="ele-toolbar-form"
          :selection.sync="selection"
          cache-key="eomContactPageTable"
        >
          <!-- 表头工具栏 -->
          <template v-slot:toolbar>
            <el-button
              size="small"
              type="primary"
              icon="el-icon-plus"
              class="ele-btn-icon"
              @click="openEdit('add', {})"
            >
              新建
            </el-button>
            <el-button
              size="small"
              type="primary"
              icon="el-icon-plus"
              class="ele-btn-icon"
              @click="addGenerateContract('all')"
              :disabled="selection?.length === 0"
            >
              生成合同
            </el-button>
            <el-button
              size="small"
              type="danger"
              el-icon-delete
              class="ele-btn-icon"
              @click="allDelBtn"
            >
              批量删除
            </el-button>
          </template>

          <!-- 查看详情列 -->
          <template v-slot:inquiryCode="{ row }">
            <el-link type="primary" :underline="false" @click="openDetail(row)">
              {{ row.inquiryCode }}</el-link
            >
          </template>
          <!-- 查看详情列 -->
          <template v-slot:planName="{ row }">
            <el-link
              type="primary"
              :underline="false"
              @click="openPlanDetail(row)"
            >
              {{ row.planName }}</el-link
            >
          </template>
          <!-- 状态 -->
          <template v-slot:status="{ row }">
            {{ getStatus(row.status) }}
          </template>

          <!-- 操作列 -->
          <template v-slot:action="{ row }">
            <el-link
              type="primary"
              :underline="false"
              icon="el-icon-edit"
              @click="openEdit('edit', row)"
              v-if="[0, 3].includes(row.status)"
            >
              修改
            </el-link>
            <el-link
              type="primary"
              :underline="false"
              icon="el-icon-plus"
              @click="sub(row)"
              v-if="[0, 3].includes(row.status)"
            >
              提交
            </el-link>
            <el-link
              type="primary"
              :underline="false"
              icon="el-icon-plus"
              @click="addGenerateContract('add', row)"
              v-if="[2].includes(row.status)"
            >
              生成合同
            </el-link>

            <el-popconfirm
              class="ele-action"
              title="确定要删除此信息吗？"
              @confirm="remove([row.id])"
              v-if="[0, 3].includes(row.status)"
            >
              <template v-slot:reference>
                <el-link type="danger" :underline="false" icon="el-icon-delete">
                  删除
                </el-link>
              </template>
            </el-popconfirm>
          </template>
        </ele-pro-table>
      </div>
    </el-card>

    <add-dialog ref="addDialogRef" @done="reload"></add-dialog>
    <add-dialog ref="addDialogRef" @done="reload"></add-dialog>
    <detail-dialog ref="contactDetailDialogRef"></detail-dialog>
    <planDetaillog ref="planDetaillogRef"></planDetaillog>
    <!-- 多选删除弹窗 -->
    <pop-modal
      :visible.sync="delVisible"
      content="是否确定删除？"
      @done="commitBtn"
    />
    <addContractBookDialog
      ref="addContractBookDialogRef"
      :categoryTreeList="treeList"
    ></addContractBookDialog>
  </div>
</template>

<script>
  import searchQuotation from './components/searchIndex.vue';
  import addDialog from './components/addDialog.vue';

  import addContractBookDialog from '@/views/contractManage/contractBook/components/addDialog.vue';
  import detailDialog from './components/detailDialog.vue';
  import planDetaillog from '../../purchasingManage/purchasePlanManage/components/detailDialog.vue';
  import popModal from '@/components/pop-modal';
  import dictMixins from '@/mixins/dictMixins';
  import {contactDetail, contactTypeTree} from '@/api/saleManage/contact';

  import {
    getTableList,
    deleteInformation,
    generateContract,
    submit, isHasGeneratedContractPI
  } from '@/api/purchasingManage/inquiryManage';

  export default {
    mixins: [dictMixins],
    components: {
      searchQuotation,
      popModal,
      addDialog,
      detailDialog,
      planDetaillog,
      addContractBookDialog
    },
    data() {
      return {
        selection: [], //单选中集合
        delVisible: false, //批量删除弹框状态
        loading: false, // 加载状态
        treeList: [],
        columns: [
          {
            width: 45,
            type: 'selection',
            columnKey: 'selection',
            align: 'center'
          },
          {
            columnKey: 'index',
            label: '序号',
            type: 'index',
            width: 55,
            align: 'center',
            showOverflowTooltip: true,
            fixed: 'left'
          },
          {
            prop: 'inquiryCode',
            slot: 'inquiryCode',
            label: '采购询价单编码',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 200
          },
          {
            prop: 'inquiryName',
            label: '采购询价单名称',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 200
          },
          {
            prop: 'planName',
            slot: 'planName',
            label: '采购计划单名称',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 200
          },
          {
            prop: 'productNames',
            label: '产品名称',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 140
          },
          // {
          //   prop: 'supplierNames',
          //   label: '供应商名称',
          //   align: 'center',
          //   showOverflowTooltip: true,
          //   minWidth: 200
          // },
          {
            prop: 'winnerName',
            label: '中标供应商',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 200
          },
          // {
          //   prop: 'requireDeptName',
          //   label: '需求部门',
          //   align: 'center',
          //   slot: 'requireDeptName',
          //   showOverflowTooltip: true,
          //   minWidth: 200
          // },
          // {
          //   prop: 'requireUserName',
          //   label: '需求人',
          //   align: 'center',
          //   showOverflowTooltip: true,
          //   minWidth: 140
          // },
          // {
          //   prop: 'responsibleName',
          //   label: '负责人',
          //   align: 'center',
          //   showOverflowTooltip: true,
          //   minWidth: 120
          // },
          // {
          //   prop: 'detailCount',
          //   label: '明细条数',
          //   align: 'center',
          //   showOverflowTooltip: true,
          //   minWidth: 140
          // },

          // {
          //   prop: 'finishDate',
          //   label: '完成日期',
          //   align: 'center',
          //   showOverflowTooltip: true,
          //   minWidth: 140
          // },
          {
            prop: 'createTime',
            label: '创建时间',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 180
          },
          {
            prop: 'status',
            label: '状态',
            align: 'center',
            slot: 'status',
            showOverflowTooltip: true,
            minWidth: 120
          },
          {
            prop: 'remark',
            label: '备注',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 170
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 230,
            align: 'center',
            resizable: false,
            slot: 'action',
            showOverflowTooltip: true,
            fixed: 'right'
          }
        ]
      };
    },
    computed: {},
    created() {
      this.getTreeData();
    },
    methods: {
      /* 表格数据源 */
      datasource({ page, limit, where, order }) {
        return getTableList({
          pageNum: page,
          size: limit,
          ...where
        });
      },
      //获取合同分类
      async getTreeData() {
        try {
          this.treeLoading = true;
          const res = await contactTypeTree({ type: 20 });
          this.treeLoading = false;
          if (res?.code === '0') {
            this.treeList = res.data;

            return this.treeList;
          }
        } catch (error) {}
        this.treeLoading = false;
      },
      /* 刷新表格 */
      reload(where) {
        this.$refs.table.reload({ page: 1, where });
      },
      //新增合同
      async addGenerateContract(type, row) {
        let { verify, text, ids } = this.verify(type, row);
        if (!verify) {
          this.$message.warning(text);
          return;
        }
        let contractInfo = await generateContract(ids);
        let contact = await contactDetail(contractInfo.contractVO.partbId);
        contractInfo.contractVO.contractName = contact.base.simpleName;
        this.$refs.addContractBookDialogRef.open('add', contractInfo, true,'inquiryManage');
      },
      //新增编辑
      openEdit(type, row) {
        this.$refs.addDialogRef.open(type, row, row.id);
        this.$refs.addDialogRef.$refs.form &&
          this.$refs.addDialogRef.$refs.form.clearValidate();
      },

      //批量删除
      allDelBtn() {
        if (this.selection.length === 0) return;
        let flag =  this.selection.some(item=>[1,2].includes(item.status))
        if(flag) return this.$message.warning('抱歉已审核、审核中的数据不能删除,请检查')
        this.delVisible = true;
      },

      //删除接口
      remove(delData) {
        deleteInformation(delData).then((res) => {
          this.$message.success('删除成功！');
          this.reload();
        });
      },

      //删除弹框确定
      commitBtn() {
        const dataId = this.selection.map((v) => v.id);
        this.remove(dataId);
      },

      //查看详情
      openDetail(row) {
        this.$refs.contactDetailDialogRef.open(row);
      },
      //查看详情
      openPlanDetail(row) {
        this.$refs.planDetaillogRef.open(row);
      },
      // 合同验证
      verify(type, data) {
        let verify = true;
        let text = '';
        let ids = [];
        if (type == 'add') {
          if (!data.winnerId) {
            verify = false;
            text = '核价单中标供应商为空';
          }

          if (verify) {
            ids.push(data.id);
          }
        }
        if (type == 'all') {
          let status = '';
          let winnerIds = this.selection
            .filter((item) => item.winnerId)
            .map((item) => item.winnerId);

          this.selection.forEach((item) => {
            this.selection.forEach((val) => {
              if (item.winnerId != val.winnerId) {
                verify = false;
                text = '中标供应商不一致';
              }
              if (item.status != 2) {
                verify = false;
                text = '请选择审核已通过的核价单';
              }
              // if (item.planCode != val.planCode) {
              //   verify = false;
              //   text = '采购计划不一致';
              // }
            });
          });
          if (winnerIds.length != this.selection.length) {
            verify = false;
            text = '核价单中标供应商为空';
          }
          if (verify) {
            ids = this.selection.map((item) => item.id);
          }
        }
        return { verify, text, ids };
      },
      sub(res) {
        submit({
          businessId: res.id
        })
          .then((res) => {
            this.$message.success('提交成功');
            this.reload();
          })
          .catch((e) => {
            this.$message.error(e.message);
          });
      },
      //获取状态
      getStatus(status) {
        return status == 0
          ? '未提交'
          : status == 1
          ? '审核中'
          : status == 2
          ? '审核通过'
          : status == 3
          ? '审核不通过'
          : '';
      }
    }
  };
</script>

<style lang="scss" scoped>
  :deep(.el-link--inner) {
    margin-left: 0px !important;
  }

  .sys-organization-list {
    height: calc(100vh - 264px);
    box-sizing: border-box;
    border-width: 1px;
    border-style: solid;
    overflow: auto;
  }
  .sys-organization-list :deep(.el-tree-node__content) {
    height: 40px;
    & > .el-tree-node__expand-icon {
      margin-left: 10px;
    }
  }
</style>
